package com.hzya.frame.plugin.dgx.oa.plugin;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.plugin.dgx.oa.service.impl.PaymentOrderServiceImpl;
import com.hzya.frame.plugin.dgx.oa.service.impl.SalesOrderServiceImpl;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.impl.IntegrationTaskLivingDetailsServiceImpl;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 *
 * @content OA付款单推送德广信U9C
 * @Param
 * @Return
 * @Author hecan
 * @Date 2024-11-14 9:55
 * **/
public class PaymentOrderPluginInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private PaymentOrderServiceImpl paymentOrderServiceImpl;
    @Autowired
    private IntegrationTaskLivingDetailsServiceImpl taskLivingDetailsService;


    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "PaymentOrderPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "OA付款单推送德广信U9C插件";
    }

    @Override
    public String getPluginLabel() {
        return "OA付款单推送德广信U9C插件";
    }

    @Override
    public String getPluginType() {
        return "1";
    }

    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) throws Exception {
        try {
            if(null !=requestJson){
                //如果不为空，说明是重试
                String taskDetailsId = requestJson.getString("integration_task_living_details_id");
                logger.info("======德广信付款单重试得integration_task_living_details_id为:{}=====",taskDetailsId);
                if(StrUtil.isNotEmpty(taskDetailsId)){
                    logger.info("=========开始在plugin中执行付款单重试推送U9C=====");
                    IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity = taskLivingDetailsService.get(taskDetailsId);
                    if(null != integrationTaskLivingDetailsEntity && StrUtil.isNotEmpty(integrationTaskLivingDetailsEntity.getRootAppPk())){
                        logger.info("=======德广信付款单重试查询出得json为:{}=====", integrationTaskLivingDetailsEntity.getRootAppPk());
                        requestJson.put("id",integrationTaskLivingDetailsEntity.getRootAppPk());
                        requestJson.put("details_id",integrationTaskLivingDetailsEntity.getId());
                    }
                }
                logger.info("=========开始在plugin中执行付款单推送U9C=====");
                JsonResultEntity jsonResultEntity = paymentOrderServiceImpl.queryPaymentOrderToU9C(requestJson);
                if(jsonResultEntity.getStatus().equals("200")){
                    return BaseResult.getSuccessMessageEntity(getPluginName()+"执行成功");
                }else{
                    return BaseResult.getFailureMessageEntity(getPluginName()+"执行失败");
                }
            }
        }catch (Exception e){
            logger.info("=====plugin中执行付款单推送U9C失败：{}",e.getMessage());
            return BaseResult.getFailureMessageEntity(getPluginName()+"执行失败");
        }
        return null;
    }
}
