package com.hzya.frame.plugin.dgx.oa.seeyon.service.impl;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.CfsLogEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.service.ICfsLogService;
import com.hzya.frame.plugin.dgx.oa.service.impl.SeeYonInterFaceImpl;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;



/**
 * @Description oa单据推送交行日志
 * @Author xiangerlin
 * @Date 2024/3/18 13:40
 **/
@Service
public class CfsLogServiceImpl implements ICfsLogService {

   @Autowired
   private SeeYonInterFaceImpl seeYonInterFace;

    /**
     * 保存日志
     *
     * @param entity
     * @return
     */
    @Override
    public JsonResultEntity importCfsLog(CfsLogEntity entity) {
        JSONArray jsonArray = new JSONArray();
        JSONObject data = new JSONObject();
        data.put("tab_name_ch",entity.getTab_name_ch());
        data.put("tab_name_en",entity.getTab_name_en());
        data.put("bill_code",entity.getOaWorkflowEventDataEntity().getBusinessDataStr());
        data.put("form_app_id",entity.getOaWorkflowEventDataEntity().getFormApp());
        data.put("event_type","onProcessFinished");
        data.put("id",entity.getOaWorkflowEventDataEntity().getId());
        data.put("title","");//流程标题，这个字段暂时取不到
        data.put("result",entity.getResult());//返回的报文
        if (StrUtil.isNotEmpty(entity.getResult())){
            JSONObject resultObj = JSONObject.parseObject(entity.getResult());
            JSONArray jsonArrayData = resultObj.getJSONArray("Data");
            JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArrayData.get(0)));
            String mErrorMsg = jsonData.getString("m_errorMsg");//返回的错误信息
            String mId = jsonData.getString("m_iD");//返回的m_id
            String mCode = jsonData.getString("m_code");//返回的单号
            data.put("m_errorMsg",mErrorMsg);
            data.put("m_iD",mId);
            data.put("m_code",mCode);
        }
        jsonArray.add(data);
        JSONObject jsonStr = new JSONObject();
        jsonStr.put("type","archives");
        jsonStr.put("templateCode","");
        jsonStr.put("attribute",jsonArray);
        //1、解析数据
        //2、保存日志
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("jsonStr",jsonStr);
        JsonResultEntity jsonResultEntity = seeYonInterFace.thirdInterfaceSend(jsonObject);
        //调用日志模板
        return jsonResultEntity;
    }




    private String getCode(CfsLogEntity entity){
        if (null != entity && null != entity.getOaWorkflowEventDataEntity()){
            String tableName = entity.getTab_name_en();
            String jsonStr = entity.getOaWorkflowEventDataEntity().getBusinessDataStr();
            JSONObject jsonObject = JSONObject.parseObject(jsonStr);
            if (null != jsonObject){
                String bill_code=null;
                switch (tableName){
                    case "formmain_0673"://付款单
                        bill_code=jsonObject.getJSONObject("formmain_0673").getString("field0021");
                        break;
                    case "formmain_0666"://销售订单
                        bill_code=jsonObject.getJSONObject("formmain_0666").getString("field0005");
                        break;
                }
                return bill_code;
            }
        }
        return null;
    }
}
