package com.hzya.frame.plugin.dgx.oa.service.impl;


import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.dgx.oa.dao.IPaymentDetailsLinesDao;
import com.hzya.frame.plugin.dgx.oa.dao.IPaymentDetailsUseLinesDao;
import com.hzya.frame.plugin.dgx.oa.dao.IPaymentOrderDao;
import com.hzya.frame.plugin.dgx.oa.entity.PaymentOrderDetailLinesEntity;
import com.hzya.frame.plugin.dgx.oa.entity.PaymentOrderDetailsUseLinesEntity;
import com.hzya.frame.plugin.dgx.oa.entity.PaymentOrderEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.service.impl.CfsLogServiceImpl;
import com.hzya.frame.plugin.dgx.oa.service.IPaymentOrderService;
import com.hzya.frame.plugin.dgx.u9c.service.impl.AcquireTokenServiceImpl;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.List;

public class PaymentOrderServiceImpl extends BaseService implements IPaymentOrderService {

    private IPaymentOrderDao paymentOrderDao;

    @Autowired
    private IPaymentDetailsLinesDao paymentDetailsLinesDao;

    @Autowired
    private IPaymentDetailsUseLinesDao paymentDetailsUseLinesDao;
    @Autowired
    private IIntegrationTaskLivingDetailsService taskLivingDetailsService;


    @Autowired
    public void setPaymentOrderDao(IPaymentOrderDao dao) {
        this.paymentOrderDao = dao;
        this.dao=dao;
    }

    private  static String URLTEST="http://122.224.56.190:8082";
    @Autowired
    private AcquireTokenServiceImpl acquireTokenService;

    //将OA已审批得付款单推送到U9C
    @Override
    public JsonResultEntity queryPaymentOrderToU9C(JSONObject json) {
        String sourceCode = json.getString("sourceCode");
        PaymentOrderEntity paymentOrderEntity=new PaymentOrderEntity();
        paymentOrderEntity.setDataSourceCode(sourceCode);
        try {
            List<PaymentOrderEntity> query = null;
            if(StrUtil.isNotEmpty(json.getString("id"))){
                paymentOrderEntity.setId(json.getString("id"));
                query=paymentOrderDao.queryPaymentOrderRetry(paymentOrderEntity);
            }else{
                query= paymentOrderDao.query(paymentOrderEntity);
            }
            if(CollectionUtils.isEmpty(query)){
                logger.info("====OA中没有已审核得付款单传递U9C====");
                return BaseResult.getSuccessMessageEntity("查询成功",null);
            }
            for (PaymentOrderEntity orderEntity : query) {
                orderEntity.setDataSourceCode(sourceCode);
                JSONObject jsonMain=new JSONObject();
                // jsonMain.put("DocNo",orderEntity.getDocNo());//单号   此字段不用了
                jsonMain.put("PCCode",orderEntity.getpCCode()==null?"C001":orderEntity.getpCCode());//币种
                jsonMain.put("PayDate",orderEntity.getPayDate());//付款日期
                jsonMain.put("DocumentTypeCode",orderEntity.getDocumentTypeCode());//单据类型
                jsonMain.put("SuppCode",orderEntity.getSuppCode());//供应商
                jsonMain.put("SuppName",orderEntity.getSuppName());//供应商名称
                jsonMain.put("SuppSiteCode",orderEntity.getSuppSiteCode());//供应商位置
                jsonMain.put("SuppSiteName",orderEntity.getSuppSiteName());//供应商位置名称
                jsonMain.put("CustCode",orderEntity.getCustCode());//客户
                jsonMain.put("CustName",orderEntity.getCustName());//客户名称
                jsonMain.put("CustSiteCode",orderEntity.getCustSiteCode());//客户位置
                jsonMain.put("CustSiteName",orderEntity.getCustSiteName());//客户位置名称
                String payObjType=null;
                if(orderEntity.getPayObjType().equals("2744088252311683800")){
                    payObjType="0";//客户 2744088252311683800
                }else{
                    payObjType="1";//供应商
                }
                jsonMain.put("PayObjType",payObjType);//付款对象
                jsonMain.put("DeptCode",orderEntity.getDeptCode());//部门
                jsonMain.put("ProjectCode",orderEntity.getProjectCode());//项目
                jsonMain.put("SrcBillOrgCode",orderEntity.getSrcBillOrgCode());//来源组织
                jsonMain.put("TransactorCode",orderEntity.getTransactorCode());//业务员
                jsonMain.put("Note",orderEntity.getNote());//备注
                JSONObject jsonDescFlexField=new JSONObject();
                jsonDescFlexField.put("PrivateDescSeg1",orderEntity.getPrivateDescSeg1());//单号
                jsonMain.put("DescFlexField",jsonDescFlexField);
                JSONArray jsonArray=new JSONArray();
                PaymentOrderDetailLinesEntity paymentOrderDetailLinesEntity=new PaymentOrderDetailLinesEntity();
                paymentOrderDetailLinesEntity.setFormmainId(orderEntity.getId());
                paymentOrderDetailLinesEntity.setDataSourceCode(sourceCode);
                List<PaymentOrderDetailLinesEntity> paymentOrderDetailLinesEntities = paymentDetailsLinesDao.query(paymentOrderDetailLinesEntity);
                if(CollectionUtils.isEmpty(paymentOrderDetailLinesEntities)){
                    logger.info("====OA中查询出来得付款单明细行为空====");
                    jsonMain.put("PayBillLines",jsonArray);
                }else{
                    for (PaymentOrderDetailLinesEntity orderDetailLinesEntity : paymentOrderDetailLinesEntities) {
                        JSONObject jsonDetails=new JSONObject();
                        String settlementMethodCode=null;
                        if(orderDetailLinesEntity.getSettlementMethodCode().equals("-7937303392876737290")){
                            settlementMethodCode="YZ01";//现金
                        }else if(orderDetailLinesEntity.getSettlementMethodCode().equals("920692801377095260")){
                            settlementMethodCode="YZ02";//银行
                        }else if(orderDetailLinesEntity.getSettlementMethodCode().equals("-8115207479941119383")){
                            settlementMethodCode="YZ03";//信用证
                        }else if(orderDetailLinesEntity.getSettlementMethodCode().equals("823764250156614494")){
                            settlementMethodCode="YZ04";//银行承兑汇票
                        }else if(orderDetailLinesEntity.getSettlementMethodCode().equals("8845367011189605014")){
                            settlementMethodCode="YZ05";//商业承兑汇票
                        }else if(orderDetailLinesEntity.getSettlementMethodCode().equals("4478413944029466492")){
                            settlementMethodCode="YZ06";//电汇
                        }else if(orderDetailLinesEntity.getSettlementMethodCode().equals("-8705002786699392279")){
                            settlementMethodCode="YZ07";//银行承兑汇票-票据池
                        }
                        jsonDetails.put("SettlementMethodCode",settlementMethodCode);//结算方式
                        jsonDetails.put("PayBkAccCode",orderDetailLinesEntity.getPayBkAccCode());//付款银行账号
                        jsonDetails.put("PayBACCode",orderDetailLinesEntity.getPayBACCode());//账户币种
                        jsonDetails.put("PayBkSubAccount",orderDetailLinesEntity.getPayBkSubAccount());//子账户
                        jsonDetails.put("PayACCSettlementFee",orderDetailLinesEntity.getPayACCSettlementFee());//手续费
                        jsonDetails.put("LineNum",orderDetailLinesEntity.getLineNum());//行号
                        jsonDetails.put("CashAccountCode",orderDetailLinesEntity.getCashAccountCode());//现金账号
                        jsonDetails.put("TradeDate",orderDetailLinesEntity.getTradeDate());//回单日期
                        JSONArray jsonArrayUseLine=new JSONArray();
                        PaymentOrderDetailsUseLinesEntity paymentOrderDetailsUseLinesEntity=new PaymentOrderDetailsUseLinesEntity();
                        paymentOrderDetailsUseLinesEntity.setFormmainId(orderEntity.getId());
                        paymentOrderDetailsUseLinesEntity.setDataSourceCode(sourceCode);
                        List<PaymentOrderDetailsUseLinesEntity> paymentOrderDetailsUseLinesEntities = paymentDetailsUseLinesDao.query(paymentOrderDetailsUseLinesEntity);
                        if(CollectionUtils.isEmpty(paymentOrderDetailsUseLinesEntities)){
                            logger.info("====OA中查询出来得付款单明细用途为空====");
                            jsonDetails.put("PayBillUseLines",jsonArrayUseLine);
                        }else{
                            for (PaymentOrderDetailsUseLinesEntity orderDetailsUseLinesEntity : paymentOrderDetailsUseLinesEntities) {
                                JSONObject jsonPayBillUse=new JSONObject();
                                jsonDetails.put("Maturity",orderDetailsUseLinesEntity.getMaturity());//到期日
                                String payProperty=null;
                                if(StrUtil.isEmpty(orderDetailsUseLinesEntity.getPayProperty()) ||orderDetailsUseLinesEntity.getPayProperty().equals("-4517840471053613598")){
                                    payProperty="0";//标准
                                }else if(orderDetailsUseLinesEntity.getPayProperty().equals("3562140919963140665")){
                                    payProperty="1";//保证金
                                }else if(orderDetailsUseLinesEntity.getPayProperty().equals("-1289258062492909108")){
                                    payProperty="3";//预付款
                                }else if(orderDetailsUseLinesEntity.getPayProperty().equals("5931400285590995368")){
                                    payProperty="9";//杂项
                                }
                                jsonPayBillUse.put("PayProperty",payProperty);//用途
                                jsonPayBillUse.put("Money",orderDetailsUseLinesEntity.getMoney());//金额
                                jsonPayBillUse.put("SettlementFee",orderDetailLinesEntity.getSettlementFee());//手续费
                                jsonPayBillUse.put("LineNum",orderDetailsUseLinesEntity.getLineNum());//行号
                                jsonPayBillUse.put("SuppCode",orderDetailsUseLinesEntity.getSuppCode());//代付供应商
                                jsonPayBillUse.put("SuppName",orderDetailsUseLinesEntity.getSuppName());//代付供应商名称
                                jsonPayBillUse.put("SuppSiteCode",orderDetailsUseLinesEntity.getSuppSiteCode());//代付供应商位置
                                jsonPayBillUse.put("SuppSiteName",orderDetailsUseLinesEntity.getSuppSiteName());//代付供应商位置名称
                                jsonPayBillUse.put("BizOrgCode",orderEntity.getSrcBillOrgCode());//业务组织
                                jsonPayBillUse.put("DeptCode",orderDetailsUseLinesEntity.getDeptCode());//部门
                                jsonPayBillUse.put("TransactorCode",orderDetailsUseLinesEntity.getTransactorCode());//业务员
                                jsonPayBillUse.put("ProjectCode",orderDetailsUseLinesEntity.getProjectCode());//项目
                                jsonPayBillUse.put("IncExpItemCode",orderDetailsUseLinesEntity.getIncExpItemCode());//收支项目
                                jsonPayBillUse.put("ItemMasterCode",orderDetailsUseLinesEntity.getItemMasterCode());//料品
                                jsonPayBillUse.put("CustCode",orderDetailsUseLinesEntity.getCustCode());//代付客户
                                jsonPayBillUse.put("CustName",orderDetailsUseLinesEntity.getCustName());//代付客户名称
                                jsonPayBillUse.put("CustSiteCode",orderDetailsUseLinesEntity.getCustSiteCode());//代付客户位置
                                jsonPayBillUse.put("CustSiteName",orderDetailsUseLinesEntity.getCustSiteName());//代付客户位置名称
                                jsonArrayUseLine.add(jsonPayBillUse);
                                jsonDetails.put("PayBillUseLines",jsonArrayUseLine);
                            }
                        }
                        jsonArray.add(jsonDetails);
                        jsonMain.put("PayBillLines",jsonArray);
                    }
                    String token = acquireTokenService.getToken();
                    logger.info("======获取得德广信U9Ctoken为：{}=====",token);
                    if(StrUtil.isNotEmpty(token)) {
                        String params = jsonMain.toJSONString();
                        JSONObject jsonObject1 = JSONObject.parseObject(params);
                        JSONArray jsonArray1 = new JSONArray();
                        jsonArray1.add(jsonObject1);
                        String jsonStr = String.valueOf(jsonArray1);
                        //调用U9C付款单新增接口
                        logger.info("====OA付款单传递德广信U9C得请求参数为:{}======",jsonStr);
                        String body = HttpRequest.post(URLTEST + "/U9C/webapi/PayBill/Create").header("token", token).header("content-type", "application/json").body(jsonStr).execute().body();
                        logger.info("====OA付款单传递德广信U9C得返回参数为:{}======",body);
                        boolean flag=true;
                        JSONObject jsonBody = JSONObject.parseObject(body);
                        if(jsonBody.getString("Success").equals("true")){
                            JSONArray jsonArrayData = jsonBody.getJSONArray("Data");
                            if(CollectionUtils.isNotEmpty(jsonArrayData)) {
                                JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArrayData.get(0)));
                                String mCode = jsonData.getString("m_code");
                                if (StrUtil.isNotEmpty(mCode)) {
                                    flag=true;
                                }else{
                                    flag=false;
                                }
                            }else{
                                flag=false;
                            }
                        }else{
                            flag=false;
                        }
                        //保存日志
                        IntegrationTaskLivingDetailsEntity taskLivingDetail = new IntegrationTaskLivingDetailsEntity();
                        taskLivingDetail.setCreate_time(new Date());
                        taskLivingDetail.setModify_time(new Date());
                        taskLivingDetail.setRootAppPk(orderEntity.getId());
                        taskLivingDetail.setRootAppBill(orderEntity.getDocNo()==null?orderEntity.getPrivateDescSeg1():orderEntity.getDocNo());
                        taskLivingDetail.setPluginId("PaymentOrderPluginInitializer");
                        taskLivingDetail.setId(json.getString("details_id"));
                        taskLivingDetail.setRootAppNewData(jsonStr);
                        taskLivingDetail.setNewTransmitInfo(body);
                        taskLivingDetail.setNewPushDate(new Date());
                        saveLog(json.getString("id"), flag, taskLivingDetail);
                        if(jsonBody.getString("Success").equals("true")){
                            JSONArray jsonArrayDate = jsonBody.getJSONArray("Data");
                            if(CollectionUtils.isNotEmpty(jsonArrayDate)){
                                JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArrayDate.get(0)));
                                String mCode = jsonData.getString("Code");
                                logger.info("=====德广信U9C付款单新增返回得付款订单号为:{}===",mCode);
                                if(StrUtil.isNotEmpty(mCode)){
                                       logger.info("========开始更新付款单推送标识为成功=========");
                                       orderEntity.setPushStatus(mCode);
                                       paymentOrderDao.updatePaymentOrderStatus(orderEntity);
                                        logger.info("======付款单推送状态更新成功完毕=======");
                                        return BaseResult.getSuccessMessageEntity("付款单推送成功",mCode);
                                }else{
                                    logger.info("=========OA付款单推送失败，开始更新付款单推送标识为失败:{}=====",jsonBody.getString("ResMsg"));
                                    orderEntity.setPushStatus("2");
                                    paymentOrderDao.updatePaymentOrderStatus(orderEntity);
                                    return BaseResult.getFailureMessageEntity("付款单推送失败");
                                }
                            }else{
                                logger.info("=========OA付款单推送失败，开始更新付款单推送标识为失败:{}=====",jsonBody.getString("ResMsg"));
                                orderEntity.setPushStatus("2");
                                paymentOrderDao.updatePaymentOrderStatus(orderEntity);
                                return BaseResult.getFailureMessageEntity("付款单推送失败");
                            }
                        }else{
                            logger.info("=========OA付款单推送失败，开始更新付款单推送标识为失败:{}=====",jsonBody.getString("ResMsg"));
                            orderEntity.setPushStatus("2");
                            paymentOrderDao.updatePaymentOrderStatus(orderEntity);
                            return BaseResult.getFailureMessageEntity("付款单推送失败");
                        }
                    }else{
                        logger.info("=========获取德广信U9Ctkoen失败====");
                    }

                }
            }
        }catch (Exception e){
           logger.info("===OA付款单推送德广信U9C错误:{}===",e.getMessage());
        }
        return null;
    }

    private void saveLog(String integration_task_living_details_id, Boolean flag, IntegrationTaskLivingDetailsEntity taskLivingDetail) {
        try {
            //判断，成功调用这个方法
            if (StrUtil.isEmpty(integration_task_living_details_id)) {
                if (flag) {
                    taskLivingDetailsService.saveLogToSuccess(taskLivingDetail);
                } else {
                    //失败 调用这个方法
                    taskLivingDetailsService.saveLogToFail(taskLivingDetail);
                }
            } else {
                if (flag) {
                    //如果是重试 成功调这个方法
                    taskLivingDetailsService.saveLogFailToSuccess(taskLivingDetail);
                } else {
                    //如果是重试 失败调这个方法
                    taskLivingDetailsService.updateLogFailToSuccess(taskLivingDetail);
                }
            }
        } catch (Exception e) {
            logger.error("保存日志出错:{}", e);
        }
    }


    @Override
    public Integer updatePaymentOrderStatus(JSONObject json) {
        return null;
    }
}
