package com.hzya.frame.plugin.dgx.oa.service.impl;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.dgx.oa.dao.ISalesOrderDao;
import com.hzya.frame.plugin.dgx.oa.dao.ISalesOrderDetailsDao;
import com.hzya.frame.plugin.dgx.oa.entity.SalesOrderDetailsEntity;
import com.hzya.frame.plugin.dgx.oa.entity.SalesOrderEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.service.impl.CfsLogServiceImpl;
import com.hzya.frame.plugin.dgx.oa.service.ISalesOrderService;
import com.hzya.frame.plugin.dgx.u9c.service.impl.AcquireTokenServiceImpl;
import com.hzya.frame.sysnew.application.database.dao.ISysApplicationDatabaseDao;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.List;


public class SalesOrderServiceImpl extends BaseService<SalesOrderEntity,String> implements ISalesOrderService {

    private ISalesOrderDao salesOrderDao;

    @Autowired
    private ISalesOrderDetailsDao salesOrderDetailsDao;
    @Autowired
    private IIntegrationTaskLivingDetailsService taskLivingDetailsService;


    @Autowired
    public void setSalesOrderDao(ISalesOrderDao dao) {
        this.salesOrderDao = dao;
        this.dao=dao;
    }


    private  static String URLTEST="http://122.224.56.190:8082";

    @Autowired
    private ISysApplicationDatabaseDao sysApplicationDatabaseDao;

    @Autowired
    private AcquireTokenServiceImpl acquireTokenService;

    @Autowired
    private CfsLogServiceImpl cfsLogService;


    //定时查询OA中已审核得销售订单传递U9C
    @Override
    public JsonResultEntity querySalesOrderToU9C(JSONObject json) {
        String sourceCode = json.getString("sourceCode");
        SalesOrderEntity salesOrderEntity=new SalesOrderEntity();
        salesOrderEntity.setDataSourceCode(sourceCode);
        try {
            List<SalesOrderEntity> query =null; //
            if(StrUtil.isNotEmpty(json.getString("id"))){
                //重试方法
                salesOrderEntity.setId(json.getString("id"));
                query= salesOrderDao.querySalesOrderRetry(salesOrderEntity);
            }else{
                query= salesOrderDao.query(salesOrderEntity);
            }
            if(CollectionUtils.isEmpty(query)){
                logger.info("====OA中没有已审核得销售订单传递U9C====");
                return BaseResult.getSuccessMessageEntity("查询成功",null);
            }
            for (SalesOrderEntity orderEntity : query) {
                orderEntity.setDataSourceCode(sourceCode);
                JSONObject jsonMain=new JSONObject();
                jsonMain.put("DocumentType",orderEntity.getDocumentType());//单据类型
                jsonMain.put("DocNo",orderEntity.getDocNo());//单号
                jsonMain.put("OrderBy",orderEntity.getOrderBy());//客户
                jsonMain.put("BusinessDate",orderEntity.getBusinessDate());//日期
                jsonMain.put("SaleDepartment",orderEntity.getSaleDepartment());//部门
                jsonMain.put("Seller",orderEntity.getSeller());//业务员
                jsonMain.put("IsPriceIncludeTax",true);//价格是否含税
                jsonMain.put("Memo",orderEntity.getMemo());//备注
                jsonMain.put("ConfirmTermCode",orderEntity.getConfirmTermCode());//立账条件
                JSONObject jsonDescFlexField=new JSONObject();
                jsonDescFlexField.put("PubDescSeg1",orderEntity.getPubDescSeg1());//合同号
                jsonDescFlexField.put("PubDescSeg5",orderEntity.getPubDescSeg5());//厂区
                jsonDescFlexField.put("PubDescSeg6",orderEntity.getPubDescSeg6());//贸易方式
                jsonMain.put("DescFlexField",jsonDescFlexField);
                    JSONArray jsonArray=new JSONArray();
                    SalesOrderDetailsEntity salesOrderDetailsEntity = new SalesOrderDetailsEntity();
                    salesOrderDetailsEntity.setFormmainId(orderEntity.getId());
                    salesOrderDetailsEntity.setDataSourceCode(sourceCode);
                    List<SalesOrderDetailsEntity> salesOrderDetailsEntities = salesOrderDetailsDao.query(salesOrderDetailsEntity);
                    if (CollectionUtils.isEmpty(salesOrderDetailsEntities)) {
                        logger.info("====OA中查询出来得销售订单明细为空====");
                        jsonMain.put("SOLineDTOList",jsonArray);
                    }else{
                        for (SalesOrderDetailsEntity orderDetailsEntity : salesOrderDetailsEntities) {
                            JSONObject jsonDetails=new JSONObject();
                            jsonDetails.put("DocLineNo",orderDetailsEntity.getDocLineNo());//行号
                            jsonDetails.put("ItemCode",orderDetailsEntity.getItemCode());//料号
                            String freeType=null;
                            if(StrUtil.isEmpty(orderDetailsEntity.getFreeType())){
                                freeType="-1";
                            } else if(orderDetailsEntity.getFreeType().equals("-7818294496872217619")){
                                freeType="0";
                            }else if(orderDetailsEntity.getFreeType().equals("6443958972472642867")){
                                freeType="1";
                            }
                            jsonDetails.put("FreeType",freeType);//免费品类型
                            jsonDetails.put("Project",orderEntity.getProject());//项目
                            jsonDetails.put("OrderByQtyTU",orderDetailsEntity.getOrderByQtyTU());//数量
                            jsonDetails.put("TU",orderDetailsEntity.gettU());//销售单位编码
                            jsonDetails.put("FinallyPriceTC",orderDetailsEntity.getFinallyPriceTC());//最终价
                            jsonDetails.put("TaxSchedule",orderDetailsEntity.getTaxSchedule());//税组合
                            jsonDetails.put("ShipTogetherFlag","-1");//成套发货标志
                            jsonDetails.put("Memo",orderDetailsEntity.getMemo());//备注
                            jsonDetails.put("RecTermCode",orderDetailsEntity.getRecTermCode());//收款条件
                            JSONObject jsonDesc=new JSONObject();
                            boolean falg=true;
                            if(StrUtil.isEmpty(orderDetailsEntity.getPrivateDescSeg1()) || !orderDetailsEntity.getPrivateDescSeg1().equals("5634606992081569853")){
                                falg=false;
                            } else{
                                falg=true;
                            }
                            jsonDesc.put("PrivateDescSeg1",falg);//是否处理
                            jsonDesc.put("PrivateDescSeg2",orderDetailsEntity.getPrivateDescSeg2());//项目明细
                            jsonDesc.put("PubDescSeg5",orderDetailsEntity.getPrivateDescSeg5());//厂区明细id
                            jsonDesc.put("PubDescSeg1",orderDetailsEntity.getPubDescSeg1());//合同号明细
                            jsonDetails.put("DescFlexField",jsonDesc);
                            JSONArray jsonArrayLineDTO=new JSONArray();
                            JSONObject jsonObjectShiplineDTO=new JSONObject();
                            jsonObjectShiplineDTO.put("DocSubLineNo",orderDetailsEntity.getDocLineNo());//行号
                            jsonObjectShiplineDTO.put("ItemCode",orderDetailsEntity.getItemCode());//料号
                            jsonObjectShiplineDTO.put("RequireDate",orderDetailsEntity.getRequireDate());//交期
                            jsonObjectShiplineDTO.put("DemandType",orderDetailsEntity.getDemandType());//需求分类
                            jsonObjectShiplineDTO.put("Memo",orderDetailsEntity.getMemo());//备注
                            jsonArrayLineDTO.add(jsonObjectShiplineDTO);
                            jsonDetails.put("SOShiplineDTOList",jsonArrayLineDTO);
                            jsonArray.add(jsonDetails);
                            jsonMain.put("SOLineDTOList",jsonArray);
                        }
                    }
                String token = acquireTokenService.getToken();
                logger.info("======获取得德广信U9Ctoken为：{}=====",token);
                if(StrUtil.isNotEmpty(token)) {
                    String params = jsonMain.toJSONString();
                    JSONObject jsonObject1 = JSONObject.parseObject(params);
                    JSONArray jsonArray1 = new JSONArray();
                    jsonArray1.add(jsonObject1);
                    String jsonStr = String.valueOf(jsonArray1);
                    //调用U9C销售订单新增接口
                    logger.info("====OA销售订单传递德广信U9C得请求参数为:{}======", jsonStr);
                    String body = HttpRequest.post(URLTEST + "/U9C/webapi/SO/Create").header("token", token).header("content-type", "application/json").body(jsonStr).execute().body();
                    logger.info("====OA销售订单传递德广信U9C得返回参数为:{}======", body);
                    boolean flag=true;
                    JSONObject jsonBody = JSONObject.parseObject(body);
                    if(jsonBody.getString("Success").equals("true")){
                        JSONArray jsonArrayData = jsonBody.getJSONArray("Data");
                        if(CollectionUtils.isNotEmpty(jsonArrayData)) {
                            JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArrayData.get(0)));
                            String mCode = jsonData.getString("m_code");
                            if (StrUtil.isNotEmpty(mCode)) {
                                flag=true;
                            }else{
                                flag=false;
                            }
                        }else{
                            flag=false;
                        }
                    }else{
                        flag=false;
                    }
                    //保存日志
                    IntegrationTaskLivingDetailsEntity taskLivingDetail = new IntegrationTaskLivingDetailsEntity();
                    taskLivingDetail.setCreate_time(new Date());
                    taskLivingDetail.setModify_time(new Date());
                    taskLivingDetail.setRootAppPk(orderEntity.getId());
                    taskLivingDetail.setRootAppBill(orderEntity.getDocNo());
                    taskLivingDetail.setId(json.getString("details_id"));
                    taskLivingDetail.setPluginId("SalesOrderPluginInitializer");
                    taskLivingDetail.setRootAppNewData(jsonStr);
                    taskLivingDetail.setNewTransmitInfo(body);
                    taskLivingDetail.setNewPushDate(new Date());
                    saveLog(json.getString("id"), flag, taskLivingDetail);

                    if(jsonBody.getString("Success").equals("true")){
                        JSONArray jsonArrayData = jsonBody.getJSONArray("Data");
                        if(CollectionUtils.isNotEmpty(jsonArrayData)) {
                            JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArrayData.get(0)));
                            String mCode = jsonData.getString("m_code");
                            logger.info("=====德广信U9C销售订单新增返回得销售订单号为:{}===", mCode);
                            if (StrUtil.isNotEmpty(mCode)) {
                                orderEntity.setPushStatus(mCode);
                                logger.info("========开始更新销售订单推送标识为成功=========");
                                //更新销售订单推送状态
                                salesOrderDao.updateSalesOrderStatus(orderEntity);
                                logger.info("======销售订单推送状态更新成功完毕=======");
                                return BaseResult.getSuccessMessageEntity("销售订单推送成功",mCode);
                            }else{
                                logger.info("=========OA销售订单推送失败，开始更新销售订单推送标识为失败:{}=====",jsonBody.getString("ResMsg"));
                                orderEntity.setPushStatus("2");
                                salesOrderDao.updateSalesOrderStatus(orderEntity);
                                return BaseResult.getFailureMessageEntity("销售订单推送失败");
                            }
                        }else{
                            logger.info("=========OA销售订单推送失败,开始更新销售订单推送标识为失败:{}=====",jsonBody.getString("ResMsg"));
                            orderEntity.setPushStatus("2");
                            salesOrderDao.updateSalesOrderStatus(orderEntity);
                            return BaseResult.getFailureMessageEntity("销售订单推送失败");
                        }
                    }
                    else{
                        logger.info("=========OA销售订单推送失败,开始更新销售订单推送标识为失败:{}=====",jsonBody.getString("ResMsg"));
                        orderEntity.setPushStatus("2");
                        salesOrderDao.updateSalesOrderStatus(orderEntity);
                        return BaseResult.getFailureMessageEntity("销售订单推送失败");
                    }
                }else{
                    logger.info("=========获取德广信U9Ctkoen失败====");
                }
            }
        }catch (Exception e){
            logger.info("======查询OA已审核得销售订单失败:{}====",e.getMessage());
            return BaseResult.getFailureMessageEntity("查询OA已审核得销售订单失败");
        }
        return null;
    }


    private void saveLog(String integration_task_living_details_id, Boolean flag, IntegrationTaskLivingDetailsEntity taskLivingDetail) {
        try {
            //判断，成功调用这个方法
            if (StrUtil.isEmpty(integration_task_living_details_id)) {
                if (flag) {
                    taskLivingDetailsService.saveLogToSuccess(taskLivingDetail);
                } else {
                    //失败 调用这个方法
                    taskLivingDetailsService.saveLogToFail(taskLivingDetail);
                }
            } else {
                if (flag) {
                    //如果是重试 成功调这个方法
                    taskLivingDetailsService.saveLogFailToSuccess(taskLivingDetail);
                } else {
                    //如果是重试 失败调这个方法
                    taskLivingDetailsService.updateLogFailToSuccess(taskLivingDetail);
                }
            }
        } catch (Exception e) {
            logger.error("保存日志出错:{}", e);
        }
    }



}
