package com.hzya.frame.plugin.dgx.oa.service.impl;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.plugin.dgx.oa.service.ISeeYonInterFace;
import com.hzya.frame.stringutil.StringUtil;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import com.hzya.frame.web.exception.BaseSystemException;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author 👻👻👻👻👻👻👻👻👻👻 gjh
 * @version 1.0
 * @content
 * @date 2023-08-22 9:30
 */
@Service(value = "seeYonInterFace")
public class SeeYonInterFaceImpl implements ISeeYonInterFace {

    private static final Logger logger = LoggerFactory.getLogger(SeeYonInterFaceImpl.class);
    /*** rest 用户名*/
    private static final String RESTUSERNAME = "hzyaRest";
    /*** rest 密码*/
    private static final String RESTPASSWORD = "a5ce21b8-91db-4cec-b3e3-3e44719655fd";

    private static final String sendUrl = "http://xxxx/seeyon/";

    /****
     * @Content:发起无流程表单接口实现
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2019/12/23 17:03
     * @Param [templateCode 模版编码, sendLoginName 发送人登录帐号 ,xmlData  ]
     * @return java.lang.Integer
     **/
    public static JsonResultEntity saveNoProcess(String templateCode , String interfaceUrl,String sendLoginName, String xmlData) {
        String token = getToken(RESTUSERNAME, RESTPASSWORD, sendLoginName);
        Map res = new HashMap();
        res.put("loginName", sendLoginName);
        res.put("dataXml", xmlData);
        res.put("token", token);
        String result = HttpRequest.post(sendUrl + interfaceUrl + templateCode).header("token", token).body(JSON.toJSONString(res)).execute().body();
        logger.info("无流程表单执行结果：" + result);
        return BaseResult.getFailureMessageEntity("执行成功", result);
    }

    private static String getToken(String userName, String password, String loginName) {
        JSONObject jsonObject = new JSONObject();
        /** 获取token*/

        jsonObject.put("userName", userName);
        jsonObject.put("password", password);
        jsonObject.put("loginName", loginName);
        logger.info("请求获取token开始---------------------------------------------");
        logger.info("请求参数" + jsonObject.toJSONString());
        String result = HttpUtil.post(sendUrl + "rest/token", jsonObject.toJSONString());
        logger.info("获取token结果---------------------------------------------" + result);
        logger.info("获取token结果---------------------------------------------" + result);
        jsonObject = JSONObject.parseObject(result);
        if ("".equals(result) || result == null) {
            logger.info("获取token失败！");
            throw new RuntimeException("获取token失败！");
        } else {
            String token = jsonObject.get("id").toString();
            return token;
        }
    }


    @Override
    public JsonResultEntity thirdInterfaceSend(JSONObject requestData) {
        JSONObject jsonStr = requestData.getJSONObject("jsonStr");
        if (ObjectUtils.isEmpty(jsonStr)) {
            throw new BaseSystemException("jsonStr为空！请传递参数");
        }
        //类型 flow archives
        String type = jsonStr.getString("type");
        if (StringUtils.isEmpty(type)) {
            throw new BaseSystemException("请传递类型！type 流程表单：flow 基础档案：archives");
        }
        //模版编号
        String templateCode = jsonStr.getString("templateCode");
        if (StringUtils.isEmpty(templateCode)) {
            throw new BaseSystemException("请传入模版编号！templateCode不允许为空");
        }
        String attributeArrayStr = jsonStr.getString("attribute");
        if (StringUtils.isEmpty(attributeArrayStr)) {
            throw new BaseSystemException("attribute不允许为空");
        }
        List<JSONObject> attributeArray = JSON.parseArray(attributeArrayStr, JSONObject.class);
        JsonResultEntity result = null;
        for (JSONObject jsonObject : attributeArray){
            String dataXml = createCfsTempData(jsonObject);
            String loginName = "seeyon";
            Map res = new HashMap();
            res.put("loginName", loginName);
            res.put("dataXml", dataXml);
            result = saveNoProcess( "formmain_0527","rest/form/import/", loginName, dataXml);
            logger.info("日志模板发起无流程表单结果：" + result);
        }
        return result;
    }

    private String createCfsTempData(JSONObject jsonObject){
        String xml = "<forms  version=\"2.1\"><formExport><summary  id=\"-8308614817594585886\" name=\"formmain_0527\"/><definitions><column  id=\"field0004\" type=\"0\" name=\"表单名称\" isNullable=\"false\" length=\"100\"/><column  id=\"field0005\" type=\"0\" name=\"数据库表名\" isNullable=\"false\" length=\"100\"/><column  id=\"field0006\" type=\"0\" name=\"表单ID\" isNullable=\"false\" length=\"100\"/><column  id=\"field0007\" type=\"0\" name=\"表单编号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0008\" type=\"0\" name=\"流程标题\" isNullable=\"false\" length=\"100\"/><column  id=\"field0009\" type=\"0\" name=\"事件类型\" isNullable=\"false\" length=\"100\"/><column  id=\"field0010\" type=\"0\" name=\"formApp\" isNullable=\"false\" length=\"100\"/><column  id=\"field0011\" type=\"0\" name=\"推送结果\" isNullable=\"false\" length=\"100\"/><column  id=\"field0012\" type=\"0\" name=\"流水号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0013\" type=\"0\" name=\"返回信息\" isNullable=\"false\" length=\"100\"/></definitions><values><column  name=\"表单名称\"><value><![CDATA[{}]]></value></column><column  name=\"数据库表名\"><value><![CDATA[{}]]></value></column><column  name=\"表单ID\"><value><![CDATA[{}]]></value></column><column  name=\"表单编号\"><value><![CDATA[{}]]></value></column><column  name=\"流程标题\"><value><![CDATA[{}]]></value></column><column  name=\"事件类型\"><value><![CDATA[{}]]></value></column><column  name=\"formApp\"><value><![CDATA[{}]]></value></column><column  name=\"推送结果\"><value><![CDATA[{}]]></value></column><column  name=\"流水号\"><value><![CDATA[{}]]></value></column><column  name=\"返回信息\"><value><![CDATA[{}]]></value></column></values><subForms/></formExport></forms>";
        String tabNameCh = StringUtil.nullConvert(jsonObject.getString("tab_name_ch"));
        String tabNameEn = StringUtil.nullConvert(jsonObject.getString("tab_name_en"));
        String id = StringUtil.nullConvert(jsonObject.getString("id"));
        String billCode = StringUtil.nullConvert(jsonObject.getString("bill_code"));
        String title = StringUtil.nullConvert(jsonObject.getString("title"));
        String eventType = StringUtil.nullConvert(jsonObject.getString("event_type"));
        String formApp = StringUtil.nullConvert(jsonObject.getString("form_app_id"));
        String mErrorMsg = StringUtil.nullConvert(jsonObject.getString("m_errorMsg"));
        String mId = StringUtil.nullConvert(jsonObject.getString("m_iD"));
        String mCode = StringUtil.nullConvert(jsonObject.getString("m_code"));
        String result = StringUtil.nullConvert(jsonObject.getString("result"));
        String dataXml = StrUtil.format(xml,tabNameCh,tabNameEn,id,billCode,title,eventType,formApp,mErrorMsg,mId,mCode,result);
        return dataXml;
    }
}
