package com.hzya.frame.plugin.dgx.u9c.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.hzya.frame.web.entity.BaseEntity;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * @Description 德广信U9C预付单(请款单)
 * @Author xiangerlin
 * @Date 2024/9/18 14:36
 **/
public class PrepaymentEntity extends BaseEntity {

    //开始时间  查询用
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String startTime;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    //结束时间  查询用
    private String endTime;


    // 单据号
    private String docNo;
    //单据类型id
    private String documentTypeId;
    //单据类型code
    private String documentTypeCode;
    //单据类型name
    private String documentTypeName;
    // 业务员 id
    private String transactorId;
    // 业务员 code
    private String transactorCode;
    // 业务员 name
    private String transactorName;
    // 申请日期
    private String payRFDate;
    // 部门 id
    private String deptId;
    // 部门 code
    private String deptCode;
    // 部门 name
    private String deptName;
    // 预计付款日 _表头
    private String expectPayDate;
    // 付款方式 code
    private String payModeCode;
    // 付款对象 code
    private String requestObjTypeCode;
    // 状态 code
    private String docStatusCode;
    //状态name
    private String docStatusName;
    //出纳确认
    private String cashierConfirmed;
    //币种id
    private String currencyId;
    //币种code
    private String currencyCode;
    //币种name
    private String currencyName;
    //创建时间
    private String createdOn;
    //修改时间
    private String modifiedOn;
    //数据状态 1、成功 2、失败
    private String dataStatus;
    //数据状态描述
    private String dataMsg;
    //用户手机号
    private String userPhone;
    private String gys;
    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }
    public String getDocNo() {
        return docNo;
    }

    public void setDocNo(String docNo) {
        this.docNo = docNo;
    }

    public String getTransactorId() {
        return transactorId;
    }

    public void setTransactorId(String transactorId) {
        this.transactorId = transactorId;
    }

    public String getTransactorCode() {
        return transactorCode;
    }

    public void setTransactorCode(String transactorCode) {
        this.transactorCode = transactorCode;
    }

    public String getTransactorName() {
        return transactorName;
    }

    public void setTransactorName(String transactorName) {
        this.transactorName = transactorName;
    }

    public String getPayRFDate() {
        return payRFDate;
    }

    public void setPayRFDate(String payRFDate) {
        this.payRFDate = payRFDate;
    }

    public String getDeptId() {
        return deptId;
    }

    public void setDeptId(String deptId) {
        this.deptId = deptId;
    }

    public String getDeptCode() {
        return deptCode;
    }

    public void setDeptCode(String deptCode) {
        this.deptCode = deptCode;
    }

    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    public String getExpectPayDate() {
        return expectPayDate;
    }

    public void setExpectPayDate(String expectPayDate) {
        this.expectPayDate = expectPayDate;
    }

    public String getPayModeCode() {
        return payModeCode;
    }

    public void setPayModeCode(String payModeCode) {
        this.payModeCode = payModeCode;
    }

    public String getRequestObjTypeCode() {
        return requestObjTypeCode;
    }

    public void setRequestObjTypeCode(String requestObjTypeCode) {
        this.requestObjTypeCode = requestObjTypeCode;
    }

    public String getDocStatusCode() {
        return docStatusCode;
    }

    public void setDocStatusCode(String docStatusCode) {
        this.docStatusCode = docStatusCode;
    }

    public String getDocStatusName() {
        return docStatusName;
    }

    public void setDocStatusName(String docStatusName) {
        this.docStatusName = docStatusName;
    }

    public String getCashierConfirmed() {
        return cashierConfirmed;
    }

    public void setCashierConfirmed(String cashierConfirmed) {
        this.cashierConfirmed = cashierConfirmed;
    }

    public String getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(String createdOn) {
        this.createdOn = createdOn;
    }

    public String getModifiedOn() {
        return modifiedOn;
    }

    public void setModifiedOn(String modifiedOn) {
        this.modifiedOn = modifiedOn;
    }

    public String getDocumentTypeId() {
        return documentTypeId;
    }

    public void setDocumentTypeId(String documentTypeId) {
        this.documentTypeId = documentTypeId;
    }

    public String getDocumentTypeCode() {
        return documentTypeCode;
    }

    public void setDocumentTypeCode(String documentTypeCode) {
        this.documentTypeCode = documentTypeCode;
    }

    public String getDocumentTypeName() {
        return documentTypeName;
    }

    public void setDocumentTypeName(String documentTypeName) {
        this.documentTypeName = documentTypeName;
    }

    public String getCurrencyId() {
        return currencyId;
    }

    public void setCurrencyId(String currencyId) {
        this.currencyId = currencyId;
    }

    public String getCurrencyCode() {
        return currencyCode;
    }

    public void setCurrencyCode(String currencyCode) {
        this.currencyCode = currencyCode;
    }

    public String getCurrencyName() {
        return currencyName;
    }

    public void setCurrencyName(String currencyName) {
        this.currencyName = currencyName;
    }

    public String getDataStatus() {
        return dataStatus;
    }

    public void setDataStatus(String dataStatus) {
        this.dataStatus = dataStatus;
    }

    public String getDataMsg() {
        return dataMsg;
    }

    public void setDataMsg(String dataMsg) {
        this.dataMsg = dataMsg;
    }

    public String getUserPhone() {
        return userPhone;
    }

    public void setUserPhone(String userPhone) {
        this.userPhone = userPhone;
    }

    public String getGys() {
        return gys;
    }

    public void setGys(String gys) {
        this.gys = gys;
    }
}
