package com.hzya.frame.plugin.dgx.u9c.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.sysnew.application.entity.SysApplicationEntity;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.web.entity.JsonResultEntity;

/**
 * @Description 德广信U9C插件service
 * @Author xiangerlin
 * @Date 2024/9/18 15:24
 **/
public interface IU9CPluginService {

    /**
     * u9c预付单发起OA流程
     * @param requestJson
     * @return
     */
    JsonResultEntity prepaymentStartFlow(JSONObject requestJson);

    /**
     * u9c请购单发起OA流程
     * @param requestJson
     * @return
     */
    JsonResultEntity requisitionStartFlow(JSONObject requestJson);

    /**
     * 保存日志
     * @param integration_task_living_details_id 日志表id
     * @param flag 成功失败
     * @param taskLivingDetail 日志表对象
     */
    void saveLog(String integration_task_living_details_id, Boolean flag, IntegrationTaskLivingDetailsEntity taskLivingDetail);
    //根据应用key和应用密钥获取应用编码和应用名称
    public SysExtensionApiEntity setQueryUrl(SysExtensionApiEntity sysExtensionApiEntity);

    /***
     * 执行业务代码
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2023-08-07 11:20
     * @param requestJson  德广信OA回传预付单状态到U9C
     * @return void
     **/
    JsonResultEntity backPrepaymentStartFlow(JSONObject requestJson);

    /***
     * 执行业务代码
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2023-08-07 11:20
     * @param requestJson  德广信OA请购单回传状态到U9c
     * @return void
     **/
    JsonResultEntity backRequisitionStartFlow(JSONObject requestJson);
}
