package com.hzya.frame.plugin.dgx.u9c.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.dgx.u9c.dao.IPrepaymentDao;
import com.hzya.frame.plugin.dgx.u9c.entity.PrepaymentEntity;
import com.hzya.frame.plugin.dgx.u9c.service.IPrepaymentService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @Description 德广信U9C预付单
 * @Author xiangerlin
 * @Date 2024/9/18 14:40
 **/
public class PrepaymentServiceImpl extends BaseService<PrepaymentEntity,String> implements IPrepaymentService {

    private IPrepaymentDao prepaymentDao;

    @Autowired
    public void setPrepaymentDao(IPrepaymentDao dao) {
        this.prepaymentDao = dao;
        this.dao = dao;
    }

    /**
     * 查询u9c预付单
     *
     * @param entity
     * @return
     */
    @DS("#entity.dataSourceCode")
    @Override
    public List<PrepaymentEntity> queryList(PrepaymentEntity entity) {
        List<PrepaymentEntity> list = prepaymentDao.query(entity);
        return list;
    }

    /**
     * 更新推送状态
     *
     * @param entity
     * @return
     */
    @DS("#entity.dataSourceCode")
    @Override
    public void updateStatus(PrepaymentEntity entity) {
         prepaymentDao.update(entity);
    }
}
